/************************************************************************/
/* 	Test application for Deferred Shading technology and it`s compatibility with current
/*	Chassis2 render technologies.	
/*	$id$
/*	File	: 					CMeshX.h
/*	Version	:					1.0
/*	Descript:					The mesh working class header: loading, render e.t.c
/*	Autor	:					Morock
/*	Created :					2/20/2007
/************************************************************************/
#include "dxstdafx.h"
#pragma once

//Struct of material parameters
typedef struct CMeshXMaterial 
{
	//Textures
	LPDIRECT3DTEXTURE9 pTexAlfa;
	LPDIRECT3DTEXTURE9 pTexBump;
	LPDIRECT3DTEXTURE9 pTexDiffuse;
	LPDIRECT3DTEXTURE9 pTexSpecular;
	
}CMeshXMaterial, * LPCMESHXMATERIAL;


class CMeshX
{
public:
	LPCMESHXMATERIAL	pMaterials;			//array of materials
	//The key that show the MeshX status
	bool TheMeshIsCorrect;
	//Constructor
	CMeshX();
	//Cleaning all
	~CMeshX();
	//Load mesh from .x file
	HRESULT Load_Mesh (LPDIRECT3DDEVICE9 pd3dDevice, WCHAR *MeshFileName);
	//Draw mesh
	HRESULT Draw_Mesh (LPDIRECT3DDEVICE9 pd3dDevice, ID3DXEffect * pEffect, D3DXHANDLE hShadTech);
	//Update mesh matrices: WORLD, VIEW, POSITION
		//LPDIRECT3DDEVICE9 pd3dDevice	- 3D device,
		//D3DXVECTOR3 v3Translation		- Translation vector for WORLD MATRIX computing,
		//D3DXMATRIX matCamera			- Camera matrix for VIEW matrix computing,
		//float fAspect					- Aspect ratio for PROJECTION matrix computing;
	HRESULT Update_Mesh (LPDIRECT3DDEVICE9 pd3dDevice,  D3DXVECTOR3 v3Translation,  D3DXMATRIX matCamera, float fAspect);

protected:
	LPD3DXMESH			pMesh;				//current mesh
	DWORD				dwNumMaterials;		//number of materials in mesh
	
	D3DXMATRIX matWVP,matW, matP, matV;		//Matrices: World, View, Projection

private:
};