/************************************************************************/
/* 	Test application for Deferred Shading technology and it`s compatibility with current
/*	Chassis2 render technologies.	
/*	$id$
/*	File	: 					cLight.h
/*	Version	:					1.0
/*	Descript:					The light working class header.
/*	Autor	:					Morock
/*	Created :					2/26/2007
/************************************************************************/

/*
//Light parameters in shader
float4 l_colAmbient;					// Light color
float  l_radius;						// Light radius (for point light)
float3 l_dir;						 	// Light direction (view space)
float3 l_pos;							// Light position (view space)	
//My app parameter
int    l_type;							//Type of ligth (Sun, spot(?), point)
*/
#include "dxstdafx.h"
#pragma once

#define SUN_LIGHT	1
#define POINT_LIGHT 2
#define POINT_LIGHT_ANI1 21		//Animated "Bad" point ligth
#define SPOT_LIGHT	3

class CLight
{
public:
	CLight();
	~CLight();

	//Ambient color
	D3DXVECTOR4 v4Ambient;
	//Position in world & view space
	D3DXVECTOR4	v4Position, v4PositionV;
	//Direction in world & view space
	D3DXVECTOR4 v4Direction, v4DirectionV;
	//Radius of light activity
	float		fRadius;
	//Type of light
			//SUN_LIGHT		1
			//POINT_LIGHT	2
			//SPOT_LIGHT	3
	int			iType;

	D3DXMATRIX matWV,matW, matP, matV;			//Matrices: World, View, Projection	

	//The key that show the light status
	bool TheLightIsCorrect;
	//Load light from .ld file
	HRESULT Load_Light (LPDIRECT3DDEVICE9 pd3dDevice, WCHAR *pchFileName);
	//LPDIRECT3DDEVICE9 pd3dDevice	- 3D device,
	//D3DXMATRIX matCamera			- Camera matrix for VIEW matrix computing,
	HRESULT Update_Light (LPDIRECT3DDEVICE9 pd3dDevice,  D3DXVECTOR3 v3Translation,  D3DXMATRIX matCamera, float fAspect, double fTime);

protected:

private:
};