/************************************************************************/
/* 	My little Loger	
/*	$id$
/*	File	: 					cLog.cpp
/*	Version	:					1.0
/*	Descript:					The main file for class, provided loging
/*	Autor	:					Morock
/*	Created :					2/15/2007
/************************************************************************/

#include "cLog.h" 

//CALLBACK FUNCTIONS
BOOL CALLBACK ResizeChildWindows(HWND hwndChild, LPARAM lParam)
{
	LPRECT rcParent;
	rcParent = (LPRECT) lParam;
	if (!MoveWindow(hwndChild,0,0,rcParent->right-rcParent->left-10,rcParent->bottom-rcParent->top-30, TRUE))
	{
		return FALSE;
	}
	return TRUE;
}
#pragma warning(disable : 4100)
BOOL CALLBACK RedrawChildWindows(HWND hwndChild, LPARAM lParam)
{
	if (!UpdateWindow(hwndChild)) 
	{
		return FALSE;
	}
	return TRUE;
}
LRESULT CALLBACK cMainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{	
	switch (uMsg) 
	{ 

	case WM_CREATE: 		// Initialize the window. 
		return 0; 

	case WM_PAINT:			// Paint the window's client area.
		{
			EnumChildWindows(hwnd, RedrawChildWindows, (LPARAM) 0);
			return DefWindowProc(hwnd, uMsg, wParam, lParam);//return 0;
		}

	case WM_DESTROY:		// Clean up window-specific data objects. 
		return 0; 

	case WM_SIZE:			// Set the size and position of the window. 
		{
			RECT rc;
			GetWindowRect(hwnd, &rc);
			EnumChildWindows(hwnd, ResizeChildWindows, (LPARAM) &rc);
			return 0;//DefWindowProc(hwnd, uMsg, wParam, lParam);
		}		 
		// 
		// Process other messages. 
		// 
	default: 
		return DefWindowProc(hwnd, uMsg, wParam, lParam); 
	} 
//	return 0;
}

//CONSTRUCTOR
cLog::cLog()
{
	IsInit = FALSE;
	fLogFile = NULL;
	hWndConsol = NULL;
	hWndTextOut = NULL;
	hinst = NULL; 
}

//DESTRUCTOR
cLog::~cLog()
{
	if (!IsInit) return;
	//Log a message about that log was finished :-)
	WCHAR	pchTemp[MAX_PATH], pchOut[MAX_PATH];
	//Lets get time and put it to the buffer temp sting
	SYSTEMTIME time_now;
	GetLocalTime(&time_now);
	wcscpy_s(pchOut, sizeof(L"\r\nLogging finished: "), L"\r\nLogging finished: ");
	_itow_s (time_now.wDay,pchTemp,MAX_PATH,10);	// dd
	wcscat_s(pchOut,pchTemp);
	wcscat_s(pchOut,L"/");							// dd.
	_itow_s (time_now.wMonth,pchTemp,MAX_PATH,10);			// dd.mm
	wcscat_s(pchOut,pchTemp);
	wcscat_s(pchOut,L"/");							// dd.mm.
	_itow_s (time_now.wYear,pchTemp,MAX_PATH,10);			// dd.mm.year
	wcscat_s(pchOut,pchTemp);
	//wcscpy_s(pchTemp, L"\n");						// dd.mm.year
	print(pchOut,LOG_CONST);
	
	//Destroy logger
	IsInit = FALSE;
	DestroyWindow(hWndTextOut);
	DestroyWindow(hWndConsol);
	fclose(fLogFile);
}

//INIT
bool cLog::INIT(WCHAR pchFileName[MAX_PATH], HINSTANCE hinstance, int iCmdShow)
{
	IsInit = FALSE;
	if (NULL != hinstance)
	{
		//BEG - Creating LOG Window
		hinst = hinstance;
		WNDCLASS wc; 
		// Fill in the window class structure with parameters 
		// that describe the main window. 
		wc.style = CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE; 
		wc.lpfnWndProc = (WNDPROC) cMainWndProc; 
		wc.cbClsExtra = 0; 
		wc.cbWndExtra = 0; 
		wc.hInstance = hinst; 
		wc.hIcon = LoadIcon(NULL, NULL); 
		wc.hCursor = LoadCursor(NULL, IDC_ARROW); 
		wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH); 
		wc.lpszMenuName =  NULL; 
		wc.lpszClassName = pchFileName;//L"LogWindow";
		if (!RegisterClassW(&wc)) 
		{
			MessageBoxW (NULL, L"Can`t register log window class", L"LOGGER ERROR", IDOK|MB_ICONERROR);
			//return FALSE;
		} 
		hWndConsol = CreateWindowW	(
							pchFileName,//L"LogWindow",         // name of window class 
							pchFileName,	     // title-bar string 
							WS_OVERLAPPEDWINDOW |  WS_SYSMENU, // top-level window 
							0,       // default horizontal position 
							0,       // default vertical position 
							500,       // default width 
							120,       // default height 
							(HWND) NULL,         // no owner window 
							(HMENU) NULL,        // use class menu 
							hinst,				 // handle to application instance 
							(LPVOID) NULL	     // no window-creation data 
						);
		if (!hWndConsol)
		{
			MessageBoxW (NULL, L"Can`t create log window", L"LOGGER ERROR", IDOK|MB_ICONERROR);
			//return FALSE;
		}
		else
			ShowWindow(hWndConsol, iCmdShow);
		//Creating a TextBox in the window
		hWndTextOut =   CreateWindowExW(
							0,
							L"EDIT", 
							L"",
							WS_CHILD|WS_VSCROLL|ES_MULTILINE|ES_READONLY|ES_AUTOVSCROLL,
							1,
							1,
							490,
							90,
							hWndConsol,
							(HMENU) NULL, 
							hinst,
							(LPVOID) NULL);
		if (!hWndTextOut)
		{
			MessageBoxW  (hWndConsol, L"Can`t create log edit", L"LOGGER ERROR", IDOK|MB_ICONERROR);
			DestroyWindow(hWndConsol);
			//return FALSE;
		}
		else
		{
			ShowWindow(hWndTextOut, iCmdShow);
		}
		//END - Creating LOG Window
	}
	//Creating LOG file
	errno_t err = _wfopen_s (&fLogFile, pchFileName, L"w");
	WCHAR	pchErr[MAX_PATH];
	_wcserror_s(pchErr,err);
	if (err!= 0)
	{
		MessageBoxW (hWndConsol, pchErr, L"LOGGER ERROR", IDOK|MB_ICONERROR);
		//return FALSE;
	}
IsInit = TRUE;
//Lets log about logging start :-)
WCHAR	pchTemp[MAX_PATH], pchOut[MAX_PATH];
//Lets get time and put it to the buffer temp sting
SYSTEMTIME time_now;
GetLocalTime(&time_now);
wcscpy_s(pchOut, sizeof(L"Logging started: "), L"Log started: ");
_itow_s (time_now.wDay,pchTemp,MAX_PATH,10);	// dd
wcscat_s(pchOut,pchTemp);
wcscat_s(pchOut,L"/");							// dd.
_itow_s (time_now.wMonth,pchTemp,MAX_PATH,10);			// dd.mm
wcscat_s(pchOut,pchTemp);
wcscat_s(pchOut,L"/");							// dd.mm.
_itow_s (time_now.wYear,pchTemp,MAX_PATH,10);			// dd.mm.year
wcscat_s(pchOut,pchTemp);
//wcscpy_s(pchTemp, L"\n");						// dd.mm.year
print(pchOut,LOG_CONST);
return TRUE;
}

//LOG OUT
int cLog::print(WCHAR *pchStr, int type)
{
	WCHAR	pchTemp[MAX_PATH], pchTime[20];
	WCHAR * pchOut = NULL;
	size_t cTxtLen = 0;

	if (!IsInit) return -1;

	//Lets get time and put it to the buffer temp sting
	SYSTEMTIME time_now;
	GetLocalTime(&time_now);
	wcscpy_s(pchTime,sizeof(L"\r\n{"),L"\r\n{");
	_itow_s (time_now.wHour,pchTemp,MAX_PATH,10);		// {hr
	wcscat_s(pchTime,pchTemp);
	wcscat_s(pchTime,L":");		// {hr:
	_itow_s (time_now.wMinute,pchTemp,MAX_PATH,10);	// {hr:min
	wcscat_s(pchTime,pchTemp);
	wcscat_s(pchTime,L":");		// {hr:min.
	_itow_s (time_now.wSecond,pchTemp,MAX_PATH,10);	// {hr:min.secs
	wcscat_s(pchTime,pchTemp);
	wcscat_s(pchTime,L".");
	_i64tow_s (time_now.wMilliseconds,pchTemp,MAX_PATH,10);	// {hr:min.secs
	wcscat_s(pchTime,pchTemp);
	wcscat_s(pchTime, L"} ");		// {hr:min.secs}

	//Log out
		switch(type)
		{
		case LOG_OK:				//({time} pchStr [OK])
			{
				cTxtLen = 0;
				if (cLog::hWndTextOut)
				{
					//Status message
					wcscpy_s(pchTemp,sizeof(L" [OK]"),L" [OK]");
					//Gets the text of the Logger EditBox
					cTxtLen = GetWindowTextLengthW(hWndTextOut);
					cTxtLen = cTxtLen+wcslen(pchStr);
					cTxtLen = cTxtLen+wcslen(pchTime);
					cTxtLen = cTxtLen+wcslen(pchTemp);
					cTxtLen = cTxtLen+1;
					pchOut = (WCHAR*) VirtualAlloc((LPVOID) NULL, 
						(DWORD) (cTxtLen + 1), MEM_COMMIT, 
						PAGE_READWRITE); 
					GetWindowTextW(hWndTextOut, pchOut, GetWindowTextLengthW(hWndTextOut) + 1); 
					wcscat_s(pchOut,cTxtLen,pchTime);
					wcscat_s(pchOut,cTxtLen,pchStr);
					wcscat_s(pchOut,cTxtLen,pchTemp);					
					//Set text to EditBox
					SetWindowTextW(hWndTextOut, pchOut);						
				}
				if (cLog::fLogFile)
				{
					cTxtLen=fwprintf_s(fLogFile,L"%s",pchTime);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchStr);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchTemp);
				}
				//Free memory 
				VirtualFree(pchOut, 0, MEM_RELEASE); 
				return (int)cTxtLen;
			}
			break;
		case LOG_INFO:				//({time} pchStr)
			{
				if (cLog::hWndTextOut)
				{
					//Gets the text of the Logger EditBox
					cTxtLen = GetWindowTextLengthW(hWndTextOut);
					cTxtLen = cTxtLen+wcslen(pchStr);
					cTxtLen = cTxtLen+wcslen(pchTime);
					cTxtLen = cTxtLen+1;
					pchOut = (WCHAR*) VirtualAlloc((LPVOID) NULL, 
						(DWORD) (cTxtLen + 1), MEM_COMMIT, 
						PAGE_READWRITE); 
					GetWindowTextW(hWndTextOut, pchOut, GetWindowTextLengthW(hWndTextOut) + 1); 
					wcscat_s(pchOut,cTxtLen,pchTime);
					wcscat_s(pchOut,cTxtLen,pchStr);
					//Set text to EditBox
					SetWindowTextW(hWndTextOut, pchOut);
				}
				if (cLog::fLogFile)
				{
					cTxtLen=fwprintf_s(fLogFile,L"%s",pchTime);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchStr);
				}
				//Free memory 
				VirtualFree(pchOut, 0, MEM_RELEASE); 
				return (int)cTxtLen;
			}
			break;
		case LOG_WARN:				//({time} [WARNING] pchStr)
			{
				if (cLog::hWndTextOut)
				{
					//Status message
					wcscpy_s(pchTemp,sizeof(L"[WARNING] "),L"[WARNING] ");
					//Gets the text of the Logger EditBox
					cTxtLen = GetWindowTextLengthW(hWndTextOut);
					cTxtLen = cTxtLen+wcslen(pchStr);
					cTxtLen = cTxtLen+wcslen(pchTime);
					cTxtLen = cTxtLen+wcslen(pchTemp);
					cTxtLen = cTxtLen+1;
					pchOut = (WCHAR*) VirtualAlloc((LPVOID) NULL, 
						(DWORD) (cTxtLen + 1), MEM_COMMIT, 
						PAGE_READWRITE); 
					GetWindowTextW(hWndTextOut, pchOut, GetWindowTextLengthW(hWndTextOut) + 1); 
					wcscat_s(pchOut,cTxtLen,pchTime);
					wcscat_s(pchOut,cTxtLen,pchTemp);
					wcscat_s(pchOut,cTxtLen,pchStr);
					//Set text to EditBox
					SetWindowTextW(hWndTextOut, pchOut);
				}
				if (cLog::fLogFile)
				{
					cTxtLen=fwprintf_s(fLogFile,L"%s",pchTime);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchTemp);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchStr);
				}
				//Free memory 
				VirtualFree(pchOut, 0, MEM_RELEASE); 
				return (int)cTxtLen;
			}
		    break;
		case LOG_ERR:				//({time} [ERROR] pchStr)
			{
				if (cLog::hWndTextOut)
				{
					//Status message
					wcscpy_s(pchTemp,sizeof(L"[ERROR] "),L"[ERROR] ");
					//Gets the text of the Logger EditBox
					cTxtLen = GetWindowTextLengthW(hWndTextOut);
					cTxtLen = cTxtLen+wcslen(pchStr);
					cTxtLen = cTxtLen+wcslen(pchTime);
					cTxtLen = cTxtLen+wcslen(pchTemp);
					cTxtLen = cTxtLen+1;
					pchOut = (WCHAR*) VirtualAlloc((LPVOID) NULL, 
						(DWORD) (cTxtLen + 1), MEM_COMMIT, 
						PAGE_READWRITE); 
					GetWindowTextW(hWndTextOut, pchOut, GetWindowTextLengthW(hWndTextOut) + 1); 
					wcscat_s(pchOut,cTxtLen,pchTime);
					wcscat_s(pchOut,cTxtLen,pchTemp);
					wcscat_s(pchOut,cTxtLen,pchStr);
					//Set text to EditBox
					SetWindowTextW(hWndTextOut, pchOut);
				}
				if (cLog::fLogFile)
				{
					cTxtLen=fwprintf_s(fLogFile,L"%s",pchTime);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchTemp);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchStr);
				}
				//Free memory 
				VirtualFree(pchOut, 0, MEM_RELEASE); 
				return (int)cTxtLen;
			}
		    break;
		case LOG_CONST:				//(pchStr)
			{
				if (cLog::hWndTextOut)
				{
					//Status message
					wcscpy_s(pchTemp,sizeof(L"\r\n"),L"\r\n");
					//Gets the text of the Logger EditBox
					cTxtLen = GetWindowTextLengthW(hWndTextOut);
					cTxtLen = cTxtLen+wcslen(pchStr);
					//cTxtLen = cTxtLen+wcslen(pchTime);
					cTxtLen = cTxtLen+wcslen(pchTemp);
					cTxtLen = cTxtLen+1;
					pchOut = (WCHAR*) VirtualAlloc((LPVOID) NULL, 
						(DWORD) (cTxtLen + 1), MEM_COMMIT, 
						PAGE_READWRITE); 
					GetWindowTextW(hWndTextOut, pchOut, GetWindowTextLengthW(hWndTextOut) + 1); 
					//wcscat_s(pchOut,cTxtLen,pchTime);
					wcscat_s(pchOut,cTxtLen,pchTemp);
					wcscat_s(pchOut,cTxtLen,pchStr);
					//Set text to EditBox
					SetWindowTextW(hWndTextOut, pchOut);
				}
				if (cLog::fLogFile)
				{
					cTxtLen=fwprintf_s(fLogFile,L"%s",pchTemp);
					cTxtLen+=fwprintf_s(fLogFile,L"%s",pchStr);
				}
				//Free memory 
				VirtualFree(pchOut, 0, MEM_RELEASE);
				return (int)cTxtLen;
			}
			break;
		default:
		    return 0;
			break;
		}
//	return -1;
}